 @echo off
setlocal enabledelayedexpansion enableextensions

rem RENAME THIS FILE TO ...
rem

:SETUP
	setlocal enableextensions enabledelayedexpansion

	if "%1" equ "" goto :HELP

	set bat_exedir=%cd%::
	set bat_exedir=!bat_exedir:\::=!
	set bat_exedir=!bat_exedir:::=!
	set bat_exedrive=!bat_exedir:~0,2!

	set bat_targetlocation=!bat_exedir!
	set bat_targetdrive=!bat_targetlocation:~0,2!
	set bat_targetdirfull=%~1

	set bat_detectfile=FTPdetectinfo.txt
	if "%2" neq "" set bat_detectfile=%~2

call :PARSEDIR "!bat_targetdirfull!\!bat_detectfile!"
call :PARSEDIR "!bat_retval1!"
set bat_targetdirname=!bat_retval2!
call :PARSEDIR "!bat_retval1!"
	set bat_targetdirbase=!bat_retval1!

	set bat_logfile=!bat_exedir!\%~nx0.log

	
goto :FART %*
goto :MAIN %*


:MAIN
	set /a linecount=0
	set bat_fffolder=
	set bat_ffdirname=
	set bat_fffolder=
	set bat_ffbasepath=
	set bat_calfolder=
	set bat_calpath=

	echo %date% %time% %~dpnx0 %*>"!bat_logfile!"
	echo %date% %time% %~dpnx0 %*

	if not exist "!bat_targetdirfull!\!bat_detectfile!" (
		exit /b 1
	)
	echo     for /f "usebackq tokens=*" %%a in ^(`type "!bat_targetdirfull!\!bat_detectfile!"`^) do ^(
	for /f "usebackq tokens=*" %%a in (`type "!bat_targetdirfull!\!bat_detectfile!"`) do (
		set bat_temp=%%~a

		if /i "!bat_temp:~0,10!" equ "FF  folder" (
			rem echo.
			rem echo     Changing: "!bat_temp!"
			set bat_fffolder=!bat_temp:~13,600!

			rem Remove trailing "\"
			call :PARSEDIR "!bat_fffolder!"
			rem Separate dirname from ArchivedFiles dir
			call :PARSEDIR "!bat_retval1!"
			set bat_ffdirname=!bat_retval2!
			rem Separate ArchivedFiles from basepath
			call :PARSEDIR "!bat_retval1!"
			set bat_ffbasepath=!bat_retval1!
			set bat_fffolder=FF  folder = !bat_targetdirbase!\ArchivedFiles\!bat_ffdirname!\
			set bat_temp=!bat_fffolder!
			rem echo     to      : "!bat_fffolder!"
		) else (
			if /i "!bat_temp:~0,10!" equ "CAL folder" (
				rem echo.
				rem echo     Changing: "!bat_temp!"
				set bat_calfolder=!bat_temp:~13,600!
				
				rem Remove trailing "\"
				call :PARSEDIR "!bat_calfolder!"
				rem Separate dirname from ArchivedFiles dir
				call :PARSEDIR "!bat_retval1!"
				set bat_calpath=CAL folder = !bat_targetdirbase!\Cal\
				set bat_temp=!bat_calpath!
				rem echo     to:     : "!bat_calpath!"
			) else (
				rem 
			)
		)&	rem end if /i "!bat_temp:~0,10!" equ "FF  folder" ...
		
		set bat_inputline=%%a
		
		if not defined nothing (
			set bat_outputline=!bat_temp!
			if "!bat_inputline!" neq "!bat_outputline!" (
				echo     Changing: !bat_inputline!
				echo     to:       !bat_outputline!
				echo.
			)

			rem title !bat_outputline!
			if !linecount! equ 0 (
				echo !bat_outputline!>"!bat_targetdirfull!\ftpdetectinfo.temp.txt"
			) else (
				echo !bat_outputline!>>"!bat_targetdirfull!\ftpdetectinfo.temp.txt"
			)
			set /a linecount+=1
		)
	)

rem type "!bat_targetdirfull!\ftpdetectinfo.temp.txt"
	echo copy /Y "!bat_targetdirfull!\ftpdetectinfo.temp.txt" "!bat_targetdirfull!\!bat_detectfile!"
	     copy /Y "!bat_targetdirfull!\ftpdetectinfo.temp.txt" "!bat_targetdirfull!\!bat_detectfile!"
	echo del /q "!bat_targetdirfull!\ftpdetectinfo.temp.txt"
	     del /q "!bat_targetdirfull!\ftpdetectinfo.temp.txt"

exit/b 0


:GETMETEORCOUNT
	set bat_retval=
	for /f "usebackq skip=2 tokens=1-20" %%A in (`find /i /c ".txt" "!bat_targetdirfull!\!bat_detectfile!"`) do (
		if /i "%%B" equ "" (set bat_retval=%%A)
		if /i "%%C" equ "" (set bat_retval=%%B)
		if /i "%%D" equ "" (set bat_retval=%%C)
		if /i "%%E" equ "" (set bat_retval=%%D)
		if /i "%%F" equ "" (set bat_retval=%%E)
		if /i "%%G" equ "" (set bat_retval=%%F)
		if /i "%%H" equ "" (set bat_retval=%%G)
		if /i "%%I" equ "" (set bat_retval=%%H)
		if /i "%%J" equ "" (set bat_retval=%%I)
		if /i "%%K" equ "" (set bat_retval=%%J)
		if /i "%%L" equ "" (set bat_retval=%%K)
		if /i "%%M" equ "" (set bat_retval=%%L)
		if /i "%%N" equ "" (set bat_retval=%%M)
		if /i "%%O" equ "" (set bat_retval=%%N)
		if /i "%%P" equ "" (set bat_retval=%%O)
		if /i "%%Q" equ "" (set bat_retval=%%P)
		if /i "%%R" equ "" (set bat_retval=%%Q)
		if /i "%%S" equ "" (set bat_retval=%%R)
		if /i "%%T" equ "" (set bat_retval=%%S)
	)
	
	set bat_meteorcount=bat_retval
goto :EOF


:GETSTRLEN [in] bat_string [out] bat_retval
	set bat_retval=
	set bat_string=%~1
	for /L %%a in (0,1,2000) do (
		if "!bat_string:~%%a,1!" neq "" (
			set /a bat_retval=%%a
		)
	)
	
	rem echo return-:GETSTRLEN [!bat_retval!, !bat_string!]
goto :EOF

:PARSEDIR [in] c:\cams\archivedfiles\2012_02_07_02_43_36\ [out] c:\cams\archivedfiles
	set bat_retval=
	set bat_retval1=
	set bat_retval2=
	if /i "%~1" equ "!bat_targetdrive!" goto :PARSEDIR_END

	set bat_retval1=%~dp1::
	set bat_retval1=!bat_retval1:\::=!
	set bat_retval1=!bat_retval1:::=!
	set bat_retval2=%~nx1

	rem  echo     [%~1, !bat_retval1!, !bat_retval2!]
:PARSEDIR_END
goto :EOF


:FART
	set /a linecount=0
	set bat_fffolder=
	set bat_ffdirname=
	set bat_fffolder=
	set bat_ffbasepath=
	set bat_calfolder=
	set bat_calpath=

	echo %date% %time% %~dpnx0 %*>"!bat_logfile!"
	echo %date% %time% %~dpnx0 %*

	if not exist "!bat_targetdirfull!\!bat_detectfile!" (
		exit /b 1
	)

	for /f "usebackq tokens=* skip=2" %%a in (`find /i "FF  folder" "!bat_targetdirfull!\!bat_detectfile!"`) do (
		set bat_inputline=%%~a
		set bat_fffolder=!bat_inputline:~13,600!
		set bat_fffolder=!bat_fffolder:~0,-1!
	)

	if defined bat_fffolder (
		rem Separate dirname from ArchivedFiles dir
		call :PARSEDIR "!bat_fffolder!"
		set bat_ffdirname=!bat_retval2!
		rem Separate ArchivedFiles from basepath
		call :PARSEDIR "!bat_retval1!"
		set bat_ffbasepath=!bat_retval1!
		set bat_outputline=!bat_targetdirbase!\ArchivedFiles\!bat_ffdirname!
		rem echo     to      : "!bat_fffolder!"

		echo '    call "!bat_exedir!\ReplaceText.exe" -i "!bat_targetdirfull!\!bat_detectfile!" "!bat_fffolder!" "!bat_outputline!"
		          call "!bat_exedir!\ReplaceText.exe" -i "!bat_targetdirfull!\!bat_detectfile!" "!bat_fffolder!" "!bat_outputline!"
	)


	for /f "usebackq tokens=* skip=2" %%a in (`find /i "CAL folder" "!bat_targetdirfull!\!bat_detectfile!"`) do (
		set bat_inputline=%%~a
		set bat_calfolder=!bat_inputline:~13,600!
		set bat_calfolder=!bat_calfolder:~0,-1!

	)

	if defined bat_calfolder (
		rem Separate dirname from ArchivedFiles dir
		call :PARSEDIR "!bat_calfolder!"
		set bat_calpath=!bat_targetdirbase!\Cal
		set bat_outputline=!bat_targetdirbase!\Cal
		rem echo     to:     : "!bat_calpath!"

		echo '    call "!bat_exedir!\ReplaceText.exe" -i "!bat_targetdirfull!\!bat_detectfile!" "!bat_calfolder!" "!bat_outputline!"
		          call "!bat_exedir!\ReplaceText.exe" -i "!bat_targetdirfull!\!bat_detectfile!" "!bat_calfolder!" "!bat_outputline!"
	)
EXIT /B 0



:HELP
	@echo off
	echo.
	echo Usage: %~dpnx0 C:\CAMS\ArchivedFiles\2012_01_24_03_09_22
	echo.
	echo This script changes the path in the FTPdetectinfo.txt files
	echo to the specified path.
	echo.
	echo
exit /b 9


:DONE
